From 1f2a03a90f6673cace7f0946979d548669016d73 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Pablo=20Su=C3=A1rez=20Hern=C3=A1ndez?=
 <psuarezhernandez@suse.com>
Date: Thu, 13 Aug 2020 13:49:16 +0100
Subject: [PATCH] ansiblegate: take care of failed, skipped and
 unreachable tasks (bsc#1173911)

Add 'retcode' from ansible-playbook execution to the returned data (bsc#1173909)

Always add retcode to ansible.playbooks output

Adjust ansible.playbooks output comment properly

Add new unit test for ansible.playbooks

Add unit tests for ansible.playbooks state
---
 salt/modules/ansiblegate.py                   |  10 +-
 salt/states/ansiblegate.py                    |  51 +-
 .../unit/files/playbooks/failed_example.json  | 748 ++++++++++++++++
 .../unit/files/playbooks/success_example.json | 803 ++++++++++++++++++
 tests/unit/modules/test_ansiblegate.py        |  15 +
 tests/unit/states/test_ansiblegate.py         | 113 +++
 6 files changed, 1717 insertions(+), 23 deletions(-)
 create mode 100644 tests/unit/files/playbooks/failed_example.json
 create mode 100644 tests/unit/files/playbooks/success_example.json
 create mode 100644 tests/unit/states/test_ansiblegate.py

diff --git a/salt/modules/ansiblegate.py b/salt/modules/ansiblegate.py
index 8e28fcafa3..e76809d4ba 100644
--- a/salt/modules/ansiblegate.py
+++ b/salt/modules/ansiblegate.py
@@ -381,9 +381,9 @@ def playbooks(playbook, rundir=None, check=False, diff=False, extra_vars=None,
         'cwd': rundir,
         'cmd': ' '.join(command)
     }
-    ret = __salt__['cmd.run_all'](**cmd_kwargs)
-    log.debug('Ansible Playbook Return: %s', ret)
-    retdata = json.loads(ret['stdout'])
-    if ret['retcode']:
-        __context__['retcode'] = ret['retcode']
+    ret = __salt__["cmd.run_all"](**cmd_kwargs)
+    log.debug("Ansible Playbook Return: %s", ret)
+    retdata = json.loads(ret["stdout"])
+    if 'retcode' in ret:
+        __context__["retcode"] = retdata["retcode"] = ret["retcode"]
     return retdata
diff --git a/salt/states/ansiblegate.py b/salt/states/ansiblegate.py
index b42dc02938..d268e492e2 100644
--- a/salt/states/ansiblegate.py
+++ b/salt/states/ansiblegate.py
@@ -120,9 +120,11 @@ def _changes(plays):
         task_changes = {}
         for task in play['tasks']:
             host_changes = {}
-            for host, data in six.iteritems(task['hosts']):
-                if data['changed'] is True:
-                    host_changes[host] = data.get('diff', data.get('changes', {}))
+            for host, data in six.iteritems(task["hosts"]):
+                if data["changed"] is True:
+                    host_changes[host] = data.get("diff", data.get("changes", {}))
+                elif any(x in data for x in ["failed", "skipped", "unreachable"]):
+                    host_changes[host] = data.get("results", data.get("msg", {}))
             if host_changes:
                 task_changes[task['task']['name']] = host_changes
         if task_changes:
@@ -177,20 +179,33 @@ def playbooks(name, rundir=None, git_repo=None, git_kwargs=None, ansible_kwargs=
     if not isinstance(ansible_kwargs, dict):
         log.debug('Setting ansible_kwargs to empty dict: %s', ansible_kwargs)
         ansible_kwargs = {}
-    checks = __salt__['ansible.playbooks'](name, rundir=rundir, check=True, diff=True, **ansible_kwargs)
-    if all(not check['changed'] for check in six.itervalues(checks['stats'])):
-        ret['comment'] = 'No changes to be made from playbook {0}'.format(name)
-        ret['result'] = True
-    elif __opts__['test']:
-        ret['comment'] = 'Changes will be made from playbook {0}'.format(name)
-        ret['result'] = None
-        ret['changes'] = _changes(checks)
+    if __opts__["test"]:
+        checks = __salt__["ansible.playbooks"](name, rundir=rundir, check=True, diff=True, **ansible_kwargs)
+        if all(not check["changed"] and not check["failures"] and not check["unreachable"] and not check["skipped"] for check in six.itervalues(checks["stats"])):
+            ret["comment"] = "No changes to be made from playbook {0}".format(name)
+            ret["result"] = True
+        elif any(check["changed"] and not check["failures"] and not check["unreachable"] and not check["skipped"] for check in six.itervalues(checks["stats"])):
+            ret["comment"] = "Changes will be made from playbook {0}".format(name)
+            ret["result"] = None
+            ret["changes"] = _changes(checks)
+        else:
+            ret["comment"] = "There were some issues running the playbook {0}".format(name)
+            ret["result"] = False
+            ret["changes"] = _changes(checks)
     else:
-        results = __salt__['ansible.playbooks'](name, rundir=rundir, diff=True, **ansible_kwargs)
-        ret['comment'] = 'Changes were made by playbook {0}'.format(name)
-        ret['changes'] = _changes(results)
-        ret['result'] = all(
-            not check['failures'] and not check['unreachable']
-            for check in six.itervalues(checks['stats'])
-        )
+        results = __salt__["ansible.playbooks"](name, rundir=rundir, diff=True, **ansible_kwargs)
+        if all(not check["changed"] and not check["failures"] and not check["unreachable"] and not check["skipped"] for check in six.itervalues(results["stats"])):
+            ret["comment"] = "No changes to be made from playbook {0}".format(name)
+            ret["result"] = True
+            ret["changes"] = _changes(results)
+        else:
+            ret["changes"] = _changes(results)
+            ret["result"] = all(
+                not check["failures"] and not check["unreachable"] and not check["skipped"]
+                for check in six.itervalues(results["stats"])
+            )
+            if ret["result"]:
+                ret["comment"] = "Changes were made by playbook {0}".format(name)
+            else:
+                ret["comment"] = "There were some issues running the playbook {0}".format(name)
     return ret
diff --git a/tests/unit/modules/test_ansiblegate.py b/tests/unit/modules/test_ansiblegate.py
index 05dff4a4fa..fc562605ff 100644
--- a/tests/unit/modules/test_ansiblegate.py
+++ b/tests/unit/modules/test_ansiblegate.py
@@ -177,3 +177,18 @@ description:
                 except AssertionError:
                     proc.assert_any_call(['echo', '{"ANSIBLE_MODULE_ARGS": {"_raw_params": "arg_1", "kwarg1": "foobar"}}'], stdout=-1, timeout=1200)
                 assert ret == {"completed": True, "timeout": 1200}
+
+    @patch('salt.utils.path.which', MagicMock(return_value=True))
+    def test_ansible_playbooks_return_retcode(self):
+        '''
+        Test ansible.playbooks execution module function include retcode in the return.
+        :return:
+        '''
+        ref_out = {
+                'retcode': 0,
+                'stdout': '{"foo": "bar"}'
+        }
+        cmd_run_all = MagicMock(return_value=ref_out)
+        with patch.dict(ansible.__salt__, {'cmd.run_all': cmd_run_all}):
+            ret = ansible.playbooks("fake-playbook.yml")
+            assert 'retcode' in ret
diff --git a/tests/unit/states/test_ansiblegate.py b/tests/unit/states/test_ansiblegate.py
new file mode 100644
index 0000000000..7251c2f6d5
--- /dev/null
+++ b/tests/unit/states/test_ansiblegate.py
@@ -0,0 +1,113 @@
+# -*- coding: utf-8 -*-
+#
+# Copyright 2020 SUSE LLC
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# Import Salt Testing Libs
+from __future__ import absolute_import, print_function, unicode_literals
+
+import json
+import os
+
+import salt.states.ansiblegate as ansible
+import salt.utils.files
+import salt.utils.platform
+from tests.support.mixins import LoaderModuleMockMixin
+from tests.support.mock import MagicMock, patch
+from tests.support.runtests import RUNTIME_VARS
+from tests.support.unit import TestCase, skipIf
+
+try:
+    import pytest
+except ImportError as import_error:
+    pytest = None
+NO_PYTEST = not bool(pytest)
+
+
+@skipIf(NO_PYTEST, False)
+@skipIf(salt.utils.platform.is_windows(), "Not supported on Windows")
+class AnsiblegateTestCase(TestCase, LoaderModuleMockMixin):
+    @classmethod
+    def setUpClass(cls):
+        cls.playbooks_examples_dir = os.path.join(
+            RUNTIME_VARS.TESTS_DIR, "unit/files/playbooks/"
+        )
+
+    def setup_loader_modules(self):
+        return {ansible: {}}
+
+    @patch("salt.utils.path.which", MagicMock(return_value=True))
+    def test_ansible_playbooks_states_success(self):
+        """
+        Test ansible.playbooks states executions success.
+        :return:
+        """
+
+        with salt.utils.files.fopen(
+            os.path.join(self.playbooks_examples_dir, "success_example.json")
+        ) as f:
+            success_output = json.loads(f.read())
+
+        with patch.dict(
+            ansible.__salt__,
+            {"ansible.playbooks": MagicMock(return_value=success_output)},
+        ):
+            with patch.dict(ansible.__opts__, {"test": False}):
+                ret = ansible.playbooks("foobar")
+                self.assertTrue(ret["result"])
+                self.assertEqual(ret["comment"], "Changes were made by playbook foobar")
+                self.assertDictEqual(
+                    ret["changes"],
+                    {
+                        "py2hosts": {
+                            "Ansible copy file to remote server": {
+                                "centos7-host1.tf.local": {}
+                            }
+                        }
+                    },
+                )
+
+    @patch("salt.utils.path.which", MagicMock(return_value=True))
+    def test_ansible_playbooks_states_failed(self):
+        """
+        Test ansible.playbooks failed states executions.
+        :return:
+        """
+
+        with salt.utils.files.fopen(
+            os.path.join(self.playbooks_examples_dir, "failed_example.json")
+        ) as f:
+            failed_output = json.loads(f.read())
+
+        with patch.dict(
+            ansible.__salt__,
+            {"ansible.playbooks": MagicMock(return_value=failed_output)},
+        ):
+            with patch.dict(ansible.__opts__, {"test": False}):
+                ret = ansible.playbooks("foobar")
+                self.assertFalse(ret["result"])
+                self.assertEqual(
+                    ret["comment"], "There were some issues running the playbook foobar"
+                )
+                self.assertDictEqual(
+                    ret["changes"],
+                    {
+                        "py2hosts": {
+                            "yum": {
+                                "centos7-host1.tf.local": [
+                                    "No package matching 'rsyndc' found available, installed or updated"
+                                ]
+                            }
+                        }
+                    },
+                )
-- 
2.28.0


